<?php

defined('_JEXEC') or die;

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

$version = new JVersion();
if ('2.5' != $version->RELEASE) {
	JError::raiseError(500, "This patch is for Joomla! 2.5.x only");
}

$app    = JFactory::getApplication();
$parent = $this->parent;
$source = $parent->getPath('source');

$files = array(
	'session.php' => array(
		'path'     => '/libraries/joomla/session'
	,	'old'      => '2cf43bffdd7a8cde48aa6fe2c73418d2'
	,	'checksum' => '58665eb468a955ee34469473d73542e5'
	)
);

foreach ($files as $file => $data) {
	if (!file_exists("$source/files/patch/$file")) {
		JError::raiseError(500, "Cannot find source in $source!");
	}
	$dest = JPATH_ROOT . $data['path'] . "/$file";
	if (!file_exists($dest)) {
		JError::raiseError(500, "Cannot find destination file $file!");
	}
	if (md5_file($dest) != $data['old']) {
		if (md5_file($dest) != $data['checksum']) {
			$app->enqueueMessage("Checksum for existing $file does not match!", "error");
		}
		else {
			$app->enqueueMessage("Checksum for existing $file matches patch file - not overwriting");
		}
		continue;
	}
	JFile::copy("$source/files/patch/$file", $dest);
	if (md5_file($dest) != $data['checksum']) {
		$app->enqueueMessage("Checksum for new $file does not match!", "error");
	}
}

class SecPatchCleanup
{
	function __destruct() {
		$com = 'com_joomla2528x20151214patch';
		$db = JFactory::getDbo();
		$db->setQuery('DELETE FROM `#__extensions` WHERE `element` = ' . $db->Quote($com));
		$db->query();
		$db->setQuery('DELETE FROM `#__menu` WHERE `title` = ' . $db->Quote($com));
		$db->query();
		JFolder::delete(JPATH_ROOT . '/administrator/components/' . $com);
		JFolder::delete(JPATH_ROOT . '/components/' . $com);
	}
}

$x = new SecPatchCleanup();
